/*
  $Author: kinch $
  $Date: 1995/11/27 18:46:49 $
  $Id: suadi.c,v 1.27 1995/11/27 18:46:49 kinch Exp $
  $Source: /usr/src/usr.local/security/suadi/RCS/suadi.c,v $
  $Locker:  $

  Original work August 1994 by Dave Kinchlea <kinch@julian.uwo.ca>

  Copyright (c) 1994 The University of Western Ontario.  All rights
  reserved.  Redistribution is permitted provided that this notice is
  preserved and that due credit is given to the authors as well as The
  University of Western Ontario.

  It should be no surprise that much of this code is stolen from:

  Copyright (c) 1980 Regents of the University of California.
  All rights reserved.  The Berkeley software License Agreement
  specifies the terms and conditions for redistribution.
*/

#ifndef lint
     static char copyright[] =
            "@(#) Copyright (c) 1980 Regents of the University of California.\n\
 All rights reserved.\n";
     static char sccsid[] = "@(#)script.c	5.4 (Berkeley) 11/13/85";
/* script 5..4 is the base for suadi */
     static char rcsid[] = "$Id: suadi.c,v 1.27 1995/11/27 18:46:49 kinch Exp $";
#endif  /* not lint */

#include "suadi.h"     
/* GLOBAL variable section -- ugg but that's what happens when you steal code */

/* This is the default root password entry, in case root is not found
   in the authfilenm. 
 { name, pass, uid, gid, quota, comment, gecos, dir, shell } */

struct  passwd *supass, rootpwd = { 
  ROOTNAME, "", ROOTUID, ROOTGID,
#ifndef NO_PWD_QUOTA
 0, "", 
#endif
"", ROOTDIR, ROOTSHELL
  }; 

/* We need the following in case a root entry IS found in authfilenm. */

char    rootdir[NAME_MAX]=ROOTDIR, rootshell[NAME_MAX]=ROOTSHELL, rootname[NAME_MAX]=ROOTNAME;

char    *user=NULL;
char    progname[NAME_MAX];
char    username[NAME_MAX];      /* Needed by some to store getpwuid() information */
char	line[12] = "/dev/ptyXX";   /* Old ugly way of getting a pty */
int     NoLogging=0;     /* If true, then no logging of tty output will be done */
int	master=0;
int	slave=0;
int	child=0;
int	subchild=0;
struct	termios tt;
struct	winsize win;

#ifdef SYSV
          char *slavename;
#endif

main(int argc, char *argv[])
{
	extern char *optarg;
	extern int optind;
	int ch;
	int     cmdflg=0;  /* A command is to be executed */
	int     logflg=0;  /* Override the nologging feature */
	int	passflg=0; /* password option? */


	strcpy(progname,argv[0]);
	while ((ch = getopt(argc, argv, "lpc")) != EOF)
		switch((char)ch) {
		case 'c':
		  cmdflg++;
		  break;
		case 'l':
		  logflg++;
		  break;
		case 'p':
		  passflg++;
		  break;
		case '?':
		default:
		  USAGE;
		  exit(1);
		}
	argc -= optind;
	argv += optind;
	
	/* Initialize syslog */

	openlog(progname,SYSLOG_OPTIONS,SYSLOG_FACILITY);
	setlogmask(LOG_UPTO(SYSLOG_PRIORITY));

	/* Who is this? (needed for authentication) */

	strcpy(username,Getlogin()); /* getuid() */
	user = username;
	  
	if (user == NULL) {
	  syslog(LOG_NOTICE,"Unknown user attempting access");
	  fprintf(stderr,"I can't figure out who you are, quitting\n");
	  exit(BAD_USER);
	}
	
	/* Before we do anything else, authenticate the user -- unless we are already root*/

	if ((ch=authenticate_user((const char*)user))!= SUCCESS) {
	  fprintf(stderr,"Oops .. cannot authenticate!\n");
	  exit(ch);
	}
	    /* Ok, This person IS authenticated, let syslog know. */
	syslog(LOG_INFO,"Successful attempt, %s  on %s",
	       user, ttyname(2));

	if (passflg) {
	    /* This user would like to change their password */
	  exit(change_passwd((const char*)user));
	    
	}

	/* This is the normal case. */

	if (argc >= 1) {
	  /* we have a username, fill in suuser (UID) */
	  /* We will have to setpwfile for those that need it. */
#ifdef NO_FGETPWENT
	  setpwfile("/etc/passwd");
#endif
	  setpwent();
	  if ((supass = getpwnam(argv[0])) == NULL) {
	    syslog(LOG_ERR,"Can't su to %s: no such user",argv[0]);
	    fprintf(stderr,"Can't su to %s: no such user\n",argv[0]);
	    exit(127);
	  }
	  rootpwd.pw_uid = supass->pw_uid;
	  rootpwd.pw_gid = supass->pw_gid;
	  strcpy(rootname,supass->pw_name);
	  rootpwd.pw_name = rootname;
	  strcpy(rootdir, supass->pw_dir);
	  rootpwd.pw_dir = rootdir;
	  strcpy(rootshell,(*supass->pw_shell == '\0' ? "/bin/sh":supass->pw_shell));
	  rootpwd.pw_shell = rootshell;
	  if (debug) fprintf(stderr,"rootpwd= %s:%d:%d:%s:%s:%s\n", rootpwd.pw_name, rootpwd.pw_uid, rootpwd.pw_gid, rootpwd.pw_dir, rootpwd.pw_shell);
	  argc--;
	  argv++;
	}
	
	if (argc >= 1) {
	  { 
	    char command[MAX_SYSLOG_LEN-sizeof("Running command: %s as user %s")];
	    char *ptr;
	    int i;
	    
	    if (cmdflg) {
	      fprintf(stderr,"ah ha!\n");
	      strcpy(rootpwd.pw_shell,argv[0]);
	    }
	    ptr=command;
	    for (i=0; i<argc; i++) {
	      strncat(ptr,argv[i],(sizeof(command)-strlen(ptr))-1);
	      strncat(ptr," ",(sizeof(command)-strlen(ptr))-1);
	    }
	    if ((MAGICUID >= (int) getuid()) && (!logflg)) {
	      syslog(LOG_INFO, "Logging turned off for this run");
	      NoLogging++;
	    }
	    syslog(LOG_INFO,"Running command: %s as user %s",command,rootpwd.pw_name);
	  }
	}
	if (!NoLogging) {
	  getmaster();
	  fixtty();
	}
	  
	(void) signal(SIGCHLD, finish);
	(void) signal(SIGBUS, finish);
	(void) signal(SIGSEGV, finish);
	
	if (!NoLogging) {
	  child = fork();
	  if (child < 0) {
	    syslog(LOG_ERR,"fork: %s",strerror(errno));
	    perror("fork");
	    fail();
	  }
	  if (child == 0) {
	    subchild = child = fork();
	    if (child < 0) {
	      syslog(LOG_ERR,"fork: %s",strerror(errno));
	      perror("fork");
	      fail();
	    }
	    if (child) {
	      /* This is the second process, it reads
		 input from master pipe (fed by starting process), outputs it
		 to */
#ifdef __aix__
		  sleep(SLEEPTIME);
#endif
		  dooutput();
	    } else {
	      doshell(argc,argv);
	    }
	  }
	  /* If here, we are the starting process. All our job is IPC for the
	     other two processes.*/
	  doinput();
	} else {
	  doshell(argc,argv);
	}
}
	
void
doinput(void)
{
	char ibuf[BUFSIZE];
	int cc=0;
	fd_set readfd;

	FD_SET(0, &readfd);
	(void) close(1);  /* probably unnecessary, but no harm done */
	while (cc >= 0) {
	  select(1,&readfd,NULL,NULL,NULL);
	  (cc = read(0, ibuf, BUFSIZE)) != 0;
	  (void) write(master, ibuf, cc);
	}
	done();
}

void
finish(int dummy)
{
  int status; /* We can get away with this, because we dont care about status */
  
#ifdef NO_WAITPID
  int pid,die=0;
  while ((pid = wait(&status, WNOHANG, 0)) > 0)
    if (pid == child)
      die = 1;
  
  if (die)
    done();
#else
  if (waitpid(child,(int *)&status, WNOHANG) == child) 
    done();
#endif
  if (debug) syslog(LOG_DEBUG,"Caught Signal\n");
}

void
dooutput(void)
{
  char obuf[BUFSIZE+1];
  int cc;
  
  (void) close(0);
  
  if (debug) syslog(LOG_DEBUG,"In dooutput");
  for (;;) {
    cc = read(master, obuf,sizeof(obuf));
    if (cc < 0) {
      if (debug) syslog(LOG_DEBUG,"EOF read on master, bye bye");
      break;
    } else if (cc > 0) {
      (void) write(1, obuf, cc);
      logit(obuf,cc); 
    }       /* else (cc > 0) */
  }             /* for (;;) */
  done();
}

void
  doshell(int argc, char *argv[])
{
  /* The following MUST be static (according to putenv, probably not really 
     a concern as this function is never left, still ...) */
  static char rothome[NAME_MAX];   
  static char rotuser[NAME_MAX];   
  static char rotlog[NAME_MAX];   
  static char rotshell[NAME_MAX];   

  if (debug) syslog(LOG_DEBUG,"In doshell\n");

  if (!NoLogging) {
    (void) close(master);
    getslave();
    if (dup2(slave, 0)<0){
      syslog(LOG_ERR,"Dup2, stdin: %s",strerror(errno));
      perror("Dup2, stdin");
      fail();
    }
    if (dup2(slave, 1)<0){
      syslog(LOG_ERR,"Dup2, stdout: %s",strerror(errno));
      perror("Dup2, stdout");
      fail();
    }
    if (dup2(slave, 2)<0){
      syslog(LOG_ERR,"Dup2, stderr: %s",strerror(errno));
      perror("Dup2, stderr");
      fail();
    }
  (void) close(slave);
  }
  if (debug) syslog(LOG_DEBUG,"About to change identity");
#ifdef SETUID
  if (rootpwd.pw_uid != 0) {
    if (setuid(0) < 0) {
      syslog(LOG_ERR,"setuid failed: %s",strerror(errno));
      perror("suadi: setuid");
      fail();
    }
  }
  if (setgid(rootpwd.pw_gid) < 0) {
    syslog(LOG_ERR,"setgid failed: %s",strerror(errno));
    perror("suadi: setgid fail");
    fail();
  }
  if (initgroups(user,rootpwd.pw_gid) < 0) {
    fprintf(stderr,"suadi: initgroups failed\n");
    syslog(LOG_ERR,"initgroups failed");
    fail();
  }
  if (setuid(rootpwd.pw_uid) < 0) {
    syslog(LOG_ERR,"setuid failed: %s",strerror(errno));
    perror("suadi: setuid");
    fail();
  }
#endif

  /* Ensure all users have same environment */
#ifdef __mips__
  setenv("HOME",rootpwd.pw_dir,1);
  setenv("USER",rootpwd.pw_name,1);
  setenv("LOGNAME",rootpwd.pw_name,1);
  setenv("SHELL",rootpwd.pw_shell,1);
#else
  sprintf(rothome,"HOME=%s",rootpwd.pw_dir);
  putenv(rothome);    
  sprintf(rotuser,"USER=%s",rootpwd.pw_name);
  putenv(rotuser);    
  sprintf(rotlog,"LOGNAME=%s",rootpwd.pw_name);
  putenv(rotlog);    
  sprintf(rotshell,"SHELL=%s",rootpwd.pw_shell);
  putenv(rotshell);    
  if (debug) {
    syslog(LOG_DEBUG,"%s,%s,%s,%s",rothome,rotuser,rotlog,rotshell);
    fprintf(stderr,"%s,%s,%s,%s\n",rothome,rotuser,rotlog,rotshell);
  }
#endif
  closelog();  /* finally, close the syslog file so that the shell doesn't accidentally use it */
  if (argc >= 1) {
    argv--;
    execv(rootpwd.pw_shell, argv);
  } else {
    if (NoLogging) {
      fprintf(stderr, "This shouldn\'t happen,\n\
NoLogging should only be possible with the -c command option\n\
Quitting\n");
      syslog(LOG_ERR | SYSLOG_FACILITY, "This shouldn\'t happen,\n\
NoLogging should only be possible with the -c command option\n\
Quitting\n");
      fail();
    }
    execl(rootpwd.pw_shell, rootpwd.pw_shell, "-i", 0);
  }
  /* If here, execl failed. We have to be verbose because the initialization of syslog has been removed. */
  syslog(LOG_ERR|SYSLOG_FACILITY,"%s: exec of shell failed (%s): %s",progname,rootpwd.pw_shell,strerror(errno));
  perror(rootpwd.pw_shell);
  fail();
}

void
fixtty(void)
{
  struct termios rtt;
  
  if (debug) syslog(LOG_DEBUG,"In fixtty");
  rtt = tt; /* tt holds Master attributes */
  rtt.c_lflag = LFLAG;
  rtt.c_oflag = LFLAG;
  rtt.c_cc[VMIN] = MIN_CHAR_NUM;
  rtt.c_cc[VTIME] = MIN_CHAR_TIME;
#ifdef NO_TCGETATTR
  (void) ioctl(0,TCSETA,&rtt);
#else
  (void) tcsetattr(0,TCSAFLUSH,&rtt);
#endif
  if (debug) syslog(LOG_DEBUG,"Out fixtty");
}

void 
fail(void)
{
  syslog(LOG_ERR,"Failure");
	(void) kill(0, SIGTERM);
	done();
}

void
done(void)
{

	if (subchild) {
		syslog(LOG_INFO,"\nfinished");
		(void) close(master);
		(void) fflush(stderr);
	} else {
#ifdef NO_TCGETATTR
	        (void) ioctl(0,TCSETA,(char *) &tt);
#else
		(void) tcsetattr(0, TCSAFLUSH, &tt);
#endif
	}
	closelog();
	exit(0);
}

void
getmaster(void)
{

#ifdef SYSV
          extern char *ptsname(int);

          if ((master = open("/dev/ptmx", O_RDWR)) == -1) {   /* open master */
	    syslog(LOG_ERR,"Can't open master pty");
	    perror("Can't open master pty");
	    fail();
	  }
          if (grantpt(master)) {                      /* change permission ofslave */
	    syslog(LOG_ERR,"Can't grant pty");
	    perror("Can't grant pty");
	    fail();
	  }
          if (unlockpt(master)) {                     /* unlock slave */
	    syslog(LOG_ERR,"Can't unlock pty");
	    perror("Can't unlock pty");
	    fail();
	  }
          if ((slavename = ptsname(master)) == NULL) {          /* get name of slave */
	    syslog(LOG_ERR,"ptsname fail, (this shouldn't happen)");
	    perror("ptsname fail (this shouldn't happen)");
	    fail();
	  }
	  (void)tcgetattr(0,&tt);
	  (void)ioctl(0,TIOCGWINSZ,(char *)&win);
	  return;
#else      /* The BSD way */
	char *pty, *bank, *cp;
	struct stat stb;

	pty = &line[strlen("/dev/ptyp")];
	for (bank = "pqrstuvwxyz"; *bank; bank++) {
		line[strlen("/dev/pty")] = *bank;
		*pty = '0';
		if (stat(line, &stb) < 0)
			break;
		for (cp = "0123456789abcdef"; *cp; cp++) {
			*pty = *cp;
			master = open(line, O_RDWR);
			if (master >= 0) {
				char *tp = &line[strlen("/dev/")];
				int ok;

				/* verify slave side is usable */
				*tp = 't';
				ok = access(line, R_OK|W_OK) == 0;
				*tp = 'p';
				if (ok) {
#ifdef NO_TCGETATTR
				  (void) ioctl(0,TCGETA,(char *)&tt);
#else
				  (void) tcgetattr(0,&tt);
#endif
				  (void) ioctl(0, TIOCGWINSZ, (char *)&win);
				  if (debug) syslog(LOG_DEBUG,"Successful Out getmaster");
				  return;
				}
				(void) close(master);
			      } else {
				if (debug) syslog(LOG_DEBUG,"Open of pty fail, %s: %s",line,strerror(errno));
				if (debug) perror(line);
			      }
		      }
	      }
	  syslog(LOG_ERR,"Out of pty's\n");
	  fprintf(stderr, "Out of pty's\n");
	  fail();
#endif
}

void
getslave(void)
{
	int t;
if (debug) syslog(LOG_DEBUG,"In getslave\n");
#ifdef SYSV
        (void) setpgrp();
	if ((slave = open(slavename, O_RDWR)) == -1) {    /* open slave */
	  syslog(LOG_ERR,"%s: %s",slavename,strerror(errno));
	  perror(slavename);
	  fail();
	}
	(void)ioctl(slave, I_PUSH, "ptem");        /* push ptem */
	(void)ioctl(slave, I_PUSH, "ldterm");      /* push ldterm */
#else
	t = open("/dev/tty", O_RDWR);
	if (t >= 0) {
		if (ioctl(t, TIOCNOTTY, (char *)0) == -1) {
		  syslog(LOG_ERR,"IOCTL, No controlling terminal: %s",strerror(errno));
		  perror("IOCTL, No controlling terminal");
		}
		(void) close(t);
		if (debug) syslog(LOG_DEBUG,"Closed /dev/tty\n");
	}

	line[strlen("/dev/")] = 't';
	slave = open(line, O_RDWR);
	if (slave < 0) {
	        syslog(LOG_ERR,"%s: %s",line,strerror(errno));
		perror(line);
		fail();
	}
#endif

#ifdef NO_TCGETATTR
	(void) ioctl(slave,TCSETA,(char *)&tt);
#else
	(void) tcsetattr(slave,TCSAFLUSH,&tt);
#endif
	(void) ioctl(slave, TIOCSWINSZ, (char *)&win);
#ifdef TIOCSCTTY
	(void) ioctl(slave, TIOCSCTTY, 0);

	
#endif /*TIOCSCTTY */

	if (debug) syslog(LOG_DEBUG,"Done getslave");
}

int
authenticate_user(const char *user)
{
/*
   The authentication is not based on /etc/passwd, rather on a specific file
   for this program. The filename is: AUTHFILE (suadi.h).


   As the passwd file is not /bin/passwd, we cannot use getpwent* family, 
instead we use the fgetpwent() function.
*/

  FILE    *authfileptr;
  char   *password;
  struct passwd *authpwd;
  int fd;
  char    *authfilenm = AUTHFILE;


#ifdef NO_FGETPWENT
#define fgetpwent(x) getpwent()
  setpwfile(authfilenm);
#else
  if ((authfileptr = fopen(authfilenm,"r")) == NULL) {
    syslog(LOG_ERR,"Authentication file open failed:%s",strerror(errno));
    perror(authfilenm);
    return(SYSFAIL);
  }
#endif
  /* We assume that the root entry in authfilenm will be the first entry, 
     and so if the user entry is found first, there IS not root entry.
     The test (below) will be if rootpwd.pw_name != NULL), so we ensure
     that this is the default. */
  
  rootpwd.pw_name = NULL;
  

  while ((authpwd = fgetpwent(authfileptr)) != NULL) {
    if (!strcmp(authpwd->pw_name,user)) break;
    if (!strcmp(authpwd->pw_name,ROOTNAME)) {
      /* We must make explicit copies, the info gets overwritten
	 the next call through. */
      strcpy(rootdir,authpwd->pw_dir);  
      strcpy(rootshell,authpwd->pw_shell); 
      rootpwd.pw_name = ROOTNAME; 
      rootpwd.pw_dir  = rootdir;
      rootpwd.pw_shell = rootshell;
      rootpwd.pw_uid = authpwd->pw_uid;
      rootpwd.pw_gid = authpwd->pw_gid;
    }
  }

#ifndef NO_FGETPWENT
  (void)fclose(authfileptr);
#endif

  if (authpwd) {
    if (0!=getuid()) {
#ifdef __mips__
      fd = open("/dev/tty",O_RDWR);
      if (fd < 0) {
	perror("Can't open /dev/tty");
	syslog(LOG_ERR,"Can't open /dev/tty:%s",strerror(errno));
	return(SYSFAIL);
      }
#endif

      password = getpass("Password:");
      if (strcmp(authpwd->pw_passwd,crypt(password,authpwd->pw_passwd)) != 0) {
	syslog(LOG_INFO,"Bad Password, %s on %s",
	       user,ttyname(2));
	return(BAD_PASS);
      }
    } else {
      strcpy(rootdir,authpwd->pw_dir);  
      strcpy(rootshell,authpwd->pw_shell); 
      rootpwd.pw_name = ROOTNAME; 
      rootpwd.pw_dir  = rootdir;
      rootpwd.pw_shell = rootshell;
      rootpwd.pw_uid = authpwd->pw_uid;
      rootpwd.pw_gid = authpwd->pw_gid;
    }
  } else {
    fprintf(stderr,"%s is not authorized to use %s\n",user,progname);
    syslog(LOG_ALERT,"Unauthorized attempt: %s  on %s ",
	   user,ttyname(2));
    return(BAD_USER);
  }
  /* If we got here, we have a authenticated user. If rootpwd.pw_name is NULL
       then a root entry was not found in the authfilenm. */
  if (! (rootpwd.pw_name)) {
    rootpwd.pw_name = ROOTNAME;
  }
  
  return(SUCCESS);
}

void 
logit(char *inbuf, int incnt)
{
/* Log all IO to syslog, this must be buffered to:
        a) prevent long lines,
	b) ensure reasonable formating

   This function has no return value as there does not seem
   any point in telling the process that something failed 
   (it may well be a good idea to send mail to root that syslog
   appears down, later ...)
*/

  static char buffer[MAX_SYSLOG_LEN];
  static int cnt=0;

  for (;incnt>0;incnt--,inbuf++,cnt++) {
    buffer[cnt] = *inbuf;
    if (*inbuf == '\n' || cnt==MAX_SYSLOG_LEN) {
      buffer[cnt+1] = '\0';
      syslog(LOG_DEBUG,"%s",buffer);
      cnt = -1; /* This insures that cnt will be zero for start of next loop */
    } 
  }
}


int
change_passwd(const char *user)
{
  /*
     The authentication is not based on /etc/passwd, rather on a specific file
     for this program. The filename is: AUTHFILE (suadi.h).
     
     
     As the we wish to write to the password file, we cannot use the getpwent()
     family, will have to roll my own.
     
     This routine will: flock(authfilenm), open(authfilenm,rw), find the entry
     (we KNOW it is there or this function wouldn't get called), prompt for a new 
     password and replace the entry in authfilenm (we should be able to do this 
     without rewriting the entire file).
     
  */


  FILE *authfileptr;
  char   *password, *getsalt(void), authentry[1024], *ptr, *ptr2;
  char name[10],pass[15],uid[10],gid[10],gecos[128],dir[128],shell[128];
  int fd,fd2, retval;
  char    *authfilenm = AUTHFILE;

  
  if ((fd = open(authfilenm,O_RDWR)) < 0) {
    syslog(LOG_ERR,"Authentication file open failed:%s",strerror(errno));
    perror(authfilenm);
    return(SYSFAIL);
  }

  /* Now we lockf() the file */

  if ((retval = lockf(fd, F_TLOCK, 0)) != 0) {
    fprintf(stderr,"%s locked by another user, try again later\n", authfilenm);
    perror("lockf");
    close(fd);
    return(LOCKED);
  }

  /* but we really want a file pointer not a file descriptor */

  if ((authfileptr = fdopen(fd,"r+")) == NULL) {
    syslog(LOG_ERR,"Failed to fdopen(), strange:%s",strerror(errno));
    perror("Failed to fdopen(), strange");
    lockf(fd, F_ULOCK, 0);
    close(fd); 
    return(SYSFAIL);
  }

  while (fgets(authentry,sizeof(authentry),authfileptr) != NULL) {
    if (!strncmp(authentry,user,strlen(user))) break;
  }
  
/* we need to strip out the passwd and gecos fields, might just as well
   strip them all out, it might be usefull for something later on and
   its reasonably cheap
*/

  ptr = strchr(authentry,':');
  *ptr++ = '\0'; strcpy(name,authentry);
  ptr2 = strchr(ptr,':');
  *ptr2++ = '\0'; strcpy(pass,ptr); ptr=ptr2;
  ptr2 = strchr(ptr,':');
  *ptr2++ = '\0'; strcpy(uid,ptr); ptr=ptr2;
  ptr2 = strchr(ptr,':');
  *ptr2++ = '\0'; strcpy(gid,ptr); ptr=ptr2;
  ptr2 = strchr(ptr,':');
  *ptr2++ = '\0'; strcpy(gecos,ptr); ptr=ptr2;
  ptr2 = strchr(ptr,':');
  *ptr2++ = '\0'; strcpy(dir,ptr); ptr=ptr2;
  strcpy(shell,ptr2);
  
#ifdef __mips__
  fd2 = open("/dev/tty",O_RDWR);
  if (fd2 < 0) {
    perror("Can't open /dev/tty");
    syslog(LOG_ERR,"Can't open /dev/tty:%s",strerror(errno));
    lockf(fd, F_ULOCK, 0);
    if ((fclose(authfileptr) == EOF)) {
      perror("Closing trouble");
    }
    return(SYSFAIL);
  }
#endif
  if (configure("/uwo/ccs/share/etc/libpass.rc") != SUCCESS) {
    syslog(LOG_ERR,"Couldn't configure libpass: %s",strerror(errno));
    fprintf(stderr,"Couldn't configure libpass: %s\n",strerror(errno));
    lockf(fd, F_ULOCK, 0);
    if ((fclose(authfileptr) == EOF)) {
      perror("Closing trouble");
    }
    return(SYSFAIL);
  }
  
getpasswd:  
  strcpy(pass,getpass("New Password: "));
  password = getpass("Type again to confirm: ");
  
  if (strcmp(pass, password)) {
    fprintf(stderr, "Oops ... Password Mismatch\n");
    lockf(fd, F_ULOCK, 0);
    if ((fclose(authfileptr) == EOF)) {
      perror("Closing trouble");
    }
    return(SYSFAIL);
  }
  
  if ((retval = crack(password,name,gecos,1)) != SUCCESS) {
    fprintf(stderr,"Please try again (SIGQUIT to quit)\n");
    goto getpasswd;
  }
  strcpy(pass,crypt(password,getsalt()));
  
  /* If we got here, we have a authenticated user. If rootpwd.pw_name is NULL
     then a root entry was not found in the authfilenm. */
  
  sprintf(authentry,"%s:%s:%s:%s:%s:%s:%s",
	  name,pass,uid,gid,gecos,dir,shell);
  

  if (fseek(authfileptr,-(strlen(authentry)),1) != 0) {
    syslog(LOG_ERR,"Couldn't fseek backwards, password not changed");
    fprintf(stderr,"Couldn't fseek backwards, password not changed\n");
    lockf(fd, F_ULOCK, 0);
    if ((fclose(authfileptr) == EOF)) {
      perror("Closing trouble");
    }
    return(SYSFAIL);
  }
  if (fprintf(authfileptr,"%s",authentry) < 0) {
    syslog(LOG_ERR,"Couldn't write new password for %s: %s",user,strerror(errno));
    fprintf(stderr,"Couldn't write new password for %s: %s",user,strerror(errno));
    lockf(fd, F_ULOCK, 0);
    if ((fclose(authfileptr) == EOF)) {
      perror("Closing trouble");
    }
    return(SYSFAIL);
  }
  syslog(LOG_INFO,"Changing Password for %s on %s ",
	 user,ttyname(2));
  
  if ((lockf(fd, F_ULOCK, 0)!=0) ||  (fclose(authfileptr) == EOF)) {
    perror("Closing trouble, AND otherwise done.");
  }
  return(SUCCESS);
}


char * 
getsalt(void)
{
  /* Returns a random salt for crypt, rand() will do nicely as the 
     salt is not that important */

  char salt[3];
  int num;

  srand((int)time(NULL));

  for (;;) {
    num = (rand() % 'z');
    if (num < '.') num += '0';
    if ((num > '9' && num < 'A') ||
	(num > 'Z' && num < 'a'))
      continue;    /* While this POTENIALLY could go forever, it isn't likely to */
    break;
  }
  salt[0] = num;

  for (;;) {
    num = (rand() % 'z');
    if (num < '.') num += '0';
    if ((num > '9' && num < 'A') ||
	(num > 'Z' && num < 'a'))
      continue;    /* While this POTENIALLY could go forever, it isn't likely to */
    break;
  }
  salt[1] = num;
  salt[2] = '\0';
  if (debug) fprintf(stderr,"The salt is: %s\n",salt);
  return(salt);
}
