.\" $Author: reggers $
.\" $Date: 1994/09/22 15:23:12 $
.\" $Id: suadi.man,v 1.4 1994/09/22 15:23:12 reggers Exp kinch $
.\" $Source: /usr/src/usr.local/security/suadi/RCS/suadi.man,v $
.\" $Locker: kinch $
.\"
.\" Original work August 1994 by Dave Kinchlea <kinch@julian.uwo.ca>
.\"
.TH SUADI 8 "1 November 1995"
.SH NAME
suadi \- Allow and audit root access
.SH SYNOPSIS
.B suadi \%[user [-c command]]
.br 
or
.br
.B suadi -p 
.SH DESCRIPTION
.PP
.I Suadi
is a program that combines the functionality of 
.I su(1)
and 
.I script(1).
The user who invokes this program is checked against a database
(stored in 
.B /etc/passwd
format), authenticated via
.I passwd(1)
semantics using
.I crypt(3)
(unless the envoking user is
.B root)
and then given a root shell (as determined in the 
.B suadi.passwd
file) or a shell for the user on the command line (as specified in 
.B /etc/passwd
). Anything returned to the terminal is logged via 
.IR syslog(3) .
The results, of course, should be monitored.
.SH OPTIONS
.TP
.BR \-c\ command
Rather than giving an interactive shell, this will run the equivalent
of 
.B sh -c command
for the 
.B user
specified.
.TP
.BR \-p 
This option allows an existing 
.B suadi
user to change their password. The new password is checked using the
.I libpass(2)
pro-active password checker.
.SH FILES
.TP
.B /etc/suadi.passwd 
A 
.I passwd(5)
style file containing all users who are allowed to use suadi. Each should
have a unique and non trivial password.
.SH BUGS
.PP
The authentication used is 
.B always
that of the envoking user as stored in
.I /etc/suadi.passwd
this can be confusing to historic users of
.I /bin/su user.
Under 
.B suadi
semantics, only those allowed to 
.I su root
are allowed to
.I su user
and so knowledge of the 
.B user's
password is unnecessary.

.PP
Unexpected results occur if no 
.B user
is specified when using the
.B -c command
option.
.SH SEE ALSO
.IR script(1) , 
.IR su(1) 
(particularly the 
.B Solaris(tm)
version),
.IR passwd(1) ,
.IR passwd(5) ,
.IR libpass(2) .
.SH AUTHOR
.PP
Dave Kinchlea <kinch@julian.uwo.ca>. Information Technology Services,
The University of Western Ontario. November 1995


